SystemOrganization addCategory: #'Idiom-Exercise'!

TestCase subclass: #IdiomTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!IdiomTest class methodsFor: 'testing' stamp: 'KevinKujawski 4/22/2013 20:49'!
assertTime: aBlockClosure duration: aSmallInteger initialize: aBlockClosure3 
	self shouldBeImplemented.! !

!IdiomTest methodsFor: 'refactoring' stamp: 'KevinKujawski 4/24/2013 11:16'!
fails: aClousure onFail: aFail doHandler: aHandler

	[ aClousure value.
	self fail ]
		on: aFail 
		do: [ :anError | aHandler value: anError].! !

!IdiomTest methodsFor: 'refactoring' stamp: 'KevinKujawski 4/24/2013 11:26'!
take: aClousure less: aTime 

	| millisecondsBeforeRunning millisecondsAfterRunning |
	
	millisecondsBeforeRunning := Time millisecondClockValue.
	aClousure value. 	
	millisecondsAfterRunning := Time millisecondClockValue.
	
	self assert: (millisecondsAfterRunning-millisecondsBeforeRunning) < aTime! !

!IdiomTest methodsFor: 'testing' stamp: 'KevinKujawski 4/24/2013 11:26'!
test01AddingCustomerShouldNotTakeMoreThan50Milliseconds

	| customerBook |
	
	customerBook := CustomerBook  new.
	
	self  take:  [customerBook addCustomerNamed: 'John Lennon'] less: 50

	
	
! !

!IdiomTest methodsFor: 'testing' stamp: 'KevinKujawski 4/24/2013 11:27'!
test02RemovingCustomerShouldNotTakeMoreThan100Milliseconds

	| customerBook johnLennon |
	
	customerBook := CustomerBook  new.
	johnLennon := 'John Lennon'.
	
	customerBook addCustomerNamed: johnLennon.
	  
	self take: [customerBook removeCustomerNamed: johnLennon] less: 100
! !

!IdiomTest methodsFor: 'testing' stamp: 'KevinKujawski 4/24/2013 11:30'!
test03CanNotAddACustomerWithEmptyName 
	
	| customerBook |
			
	customerBook := CustomerBook new.

	self fails:  [ customerBook addCustomerNamed: ''] 
		onFail: Error 
		doHandler: [:anError |
			self assert: (anError messageText = CustomerBook customerCanNotBeEmptyErrorMessage).
			self assert: (customerBook isEmpty )]! !

!IdiomTest methodsFor: 'testing' stamp: 'KevinKujawski 4/24/2013 11:30'!
test04CanNotRemoveAndInvalidCustomer
	
	| customerBook johnLennon |
			
	customerBook := CustomerBook new.
	johnLennon := 'John Lennon'.
	customerBook addCustomerNamed: johnLennon.

	self fails: [ customerBook removeCustomerNamed: 'Paul McCartney'] 
			onFail: NotFound 
			doHandler: [ :anError |
				self assert: (customerBook numberOfCustomers = 1).
				self assert: (customerBook includesCustomerNamed: johnLennon)]! !

Object subclass: #CustomerBook
	instanceVariableNames: 'customers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Idiom-Exercise'!

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:57'!
customerAlreadyExistsErrorMessage

	^'Customer already exists'! !

!CustomerBook class methodsFor: 'error messages' stamp: 'HernanWilkinson 7/6/2011 17:53'!
customerCanNotBeEmptyErrorMessage

	^'Customer name cannot be empty'! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:42'!
addCustomerNamed: aName

	aName isEmpty ifTrue: [ self signalCustomerNameCannotBeEmpty ].
	(customers includes: aName) ifTrue: [ self signalCustomerAlreadyExists ].
	
	customers add: aName ! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:56'!
includesCustomerNamed: aName

	^customers includes: aName ! !

!CustomerBook methodsFor: 'initialization' stamp: 'HernanWilkinson 7/6/2011 17:42'!
initialize

	super initialize.
	customers := OrderedCollection new! !

!CustomerBook methodsFor: 'testing' stamp: 'HernanWilkinson 7/6/2011 17:48'!
isEmpty
	
	^customers isEmpty  ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:56'!
numberOfCustomers
	
	^customers size! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:44'!
removeCustomerNamed: aName
 
	customers remove: aName ! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:52'!
signalCustomerAlreadyExists 

	self error: self class customerAlreadyExistsErrorMessage! !

!CustomerBook methodsFor: 'customer management' stamp: 'HernanWilkinson 7/6/2011 17:51'!
signalCustomerNameCannotBeEmpty 

	self error: self class customerCanNotBeEmptyErrorMessage ! !
